//---------------------------------------------------------------------------

#ifndef DlgMainH
#define DlgMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <ImgList.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include <Buttons.hpp>

#include <winsock.h>
#include "vtype.h"
#include <mmsystem.h>
#include "trayicon.h"
#include <Dialogs.hpp>

class CParams;
class CMixerMc;
class CMixerSp;
class CDeviceMc;
class CDeviceSp;
class CProgress;
class CSpoolSp;

class CContacts;
class CClient;
class CClients;
class CConf;
class CRinger;
class CLanguage;

class TDlgCntact;
class TDlgOption;
class TDlgAbt; 
//---------------------------------------------------------------------------
class TDlg : public TForm
{
__published:	// IDE-managed Components
        TPageControl *PageControl1;
        TTabSheet *TabSheet1;
        TListBox *ListBox1;
        TEdit *Edit1;
        TPopupMenu *PopupMenu1;
        TMenuItem *EditContact1;
        TImageList *ImageList1;
        TTimer *Timer1;
        TTabSheet *TabSheet2;
        TTabSheet *TabSheet3;
        TTabSheet *TabSheet4;
        TTabSheet *TabSheet5;
        TTabSheet *TabSheet7;
        TMenuItem *CallOut1;
        TMainMenu *MainMenu1;
        TMenuItem *File1;
        TSpeedButton *SBYes;
        TSpeedButton *SBNo;
        TListBox *ListBox2;
        TTimer *Timer2;
        TMenuItem *Options1;
        TToolBar *ToolBar1;
        TToolButton *ToolButton1;
        TToolButton *ToolButton2;
        TPanel *PanelMc;
        TSpeedButton *SpeedButtonMc;
        TProgressBar *ProgressBarMc;
        TTrackBar *TrackBarMc;
        TToolButton *ToolButton6;
        TPanel *PanelSp;
        TSpeedButton *SpeedButtonSp;
        TProgressBar *ProgressBarSp;
        TTrackBar *TrackBarSp;
        TToolButton *ToolButton7;
        TStatusBar *StatusBar1;
        TSpeedButton *SBContactAdd;
        TSpeedButton *SBContactDel;
        TToolButton *ToolButton3;
        TTabSheet *TabSheet6;
        TTrayIcon *TrayIcon1;
        TMenuItem *Help1;
        TMenuItem *http1;
        TMenuItem *About1;
        TMenuItem *SelectLanguage1;
        TOpenDialog *OpenDialog1;
        TPopupMenu *PopupMenu2;
        TMenuItem *CloseMe1;
        TMenuItem *ShowMe1;
        TMenuItem *Lang0;
        TMenuItem *Lang1;
        TMenuItem *Lang2;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall ListBox1DrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
        void __fastcall ListBox1MouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall EditContact1Click(TObject *Sender);
        void __fastcall PageControl1Enter(TObject *Sender);
        void __fastcall TabSheet1Enter(TObject *Sender);
        void __fastcall ListBox1Enter(TObject *Sender);
        void __fastcall Edit1KeyPress(TObject *Sender, char &Key);
        void __fastcall Edit1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall ListBox1MouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall Timer1Timer(TObject *Sender);
        void __fastcall CallOut1Click(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall SBYesClick(TObject *Sender);
        void __fastcall SBNoClick(TObject *Sender);
        void __fastcall ListBox2DrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
        void __fastcall ListBox2Enter(TObject *Sender);
        void __fastcall Timer2Timer(TObject *Sender);
        void __fastcall Options1Click(TObject *Sender);
        void __fastcall TrackBarMcChange(TObject *Sender);
        void __fastcall TrackBarSpChange(TObject *Sender);
        void __fastcall FormCanResize(TObject *Sender, int &NewWidth,
          int &NewHeight, bool &Resize);
        void __fastcall SpeedButtonMcClick(TObject *Sender);
        void __fastcall SpeedButtonSpClick(TObject *Sender);
        void __fastcall SBContactAddClick(TObject *Sender);
        void __fastcall SBContactDelClick(TObject *Sender);
        void __fastcall PageControl1Change(TObject *Sender);
        void __fastcall http1Click(TObject *Sender);
        void __fastcall About1Click(TObject *Sender);
        void __fastcall ShowMe1Click(TObject *Sender);
        void __fastcall CloseMe1Click(TObject *Sender);
        void __fastcall Lang0Click(TObject *Sender);
private:	// User declarations
public:		// User declarations
        __fastcall TDlg(TComponent* Owner);
void *h_Wnd;
int iLB1;
void moveFocus();
int isCloseProcess;

struct sockaddr_in addrLoop;
int sock;
int isCloseThread;
void reciverNet();
void SendTo(char *data,int len,unsigned long ip);
void SendTo(char *data,int len,char *ip);

void LB1PressYes(int i);
void LB1PressNo(int i);
void setButtons();
void enButtons(int yes, int no, int cnAdd, int cnDel);
void trayIconAnimate();
int indexIconTrayRing;
int indexIconTrayVoice;

void voiceStop();
void voiceStart();
void voiceRestart();
int *isTestVoice;
void restartMixer();
int isMixerCreate;
int muteMc;
int muteSp;
void workFrameMc(char *b);
void workFrameNet(unsigned long ip, char *b);
int countError;



CClient *cnList[5];
CClients *clients;
CSpoolSp *spoolSp;
CRinger *ringer;
CParams *params;
CContacts *contacts;
CConf *conf;
CClient *clActiv;
CLanguage *lang;
void refreshCaptions();

void statusClientActiv();
TLabel *LDuration[7];
TLabel *LCaptionDuration[7];
TMenuItem *MenuItemLangs[3];

CMixerMc *mixerMc;
CMixerSp *mixerSp;
CDeviceMc *deviceMc;
CDeviceSp *deviceSp;
CProgress *progressMc;
CProgress *progressSp;



TDlgCntact *DlgCntact;
TDlgOption *DlgOptions;
TDlgAbt *DlgAbt;

int activePageIndexPrev;
int dlgActiv;
void loadPosition();
void savePosition();


void __fastcall OnUI1(TMessage &a);
void __fastcall OnUI2(TMessage &a);
void __fastcall onMixerCallBack(TMessage &a);
BEGIN_MESSAGE_MAP
        MESSAGE_HANDLER(WM_UI1,TMessage, OnUI1);
        MESSAGE_HANDLER(WM_UI2,TMessage, OnUI2);
       	MESSAGE_HANDLER(MM_MIXM_LINE_CHANGE,TMessage,onMixerCallBack)
	MESSAGE_HANDLER(MM_MIXM_CONTROL_CHANGE,TMessage,onMixerCallBack)
END_MESSAGE_MAP(TComponent)

};
//---------------------------------------------------------------------------
extern PACKAGE TDlg *Dlg;
//---------------------------------------------------------------------------
#endif
