/*
 * Copyright 2004 by Ivan Sorokin.
 *THERE IS ABSOLUTELY NO WARRANTY FOR THIS SOFTWARE.
 * http://phonesnd.com
 * mailto: phonesnd@yandex.ru  
*/

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "DlgContact.h"
#include "params.h"
#include "contacts.h"
#include "netUtils.h"
#include "cLanguage.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
__fastcall TDlgCntact::TDlgCntact(TComponent* Owner,CParams *params)
        : TForm(Owner)
{
 this->params = params;
 h_Wnd = (void*)params->getValue("_hWndMain");
 lang = (CLanguage*)params->getValue("_CLanguage");
 contacts = (CContacts*)params->getValue("_CContacts");
 clear();
 dlgActiv = 0;
}

void TDlgCntact::select(int i)
{
 CContact *contact = contacts->contact(i);
 if(contact == 0)return;
 ip = contact->ip;
 name = contact->name;
 EIp->Text = ip;
 EName->Text = name;
}

void TDlgCntact::edit(int i)
{
 clear();
 CContact *contact = contacts->contact(i);
 if(contact != 0)
 {
  ip = contact->ip;
  name = contact->name;
  EIp->Text = ip;
  EName->Text = name;
 }
 Show();
}

void TDlgCntact::edit(char *ip)
{
 clear();
}
void TDlgCntact::edit(char *ip, char *name)
{
 clear();
}

void __fastcall TDlgCntact::BCloseClick(TObject *Sender)
{
 Close();
}
void __fastcall TDlgCntact::BClearClick(TObject *Sender)
{
 clear();
 EIp->SetFocus();
}
void TDlgCntact::clear()
{
 ip="";
 name="";
 EIp->Text = ip;
 EName->Text = name;
 LMsgError->Caption = "";
 timerMsg = 0;
}


void __fastcall TDlgCntact::EIpKeyPress(TObject *Sender, char &Key)
{
 if(Key == '.') return;
 if(Key == '\b') return;
 if((Key >= '0')&&( Key <= '9'))return;
 Key =0;
}
//---------------------------------------------------------------------------

void __fastcall TDlgCntact::BRenameClick(TObject *Sender)
{
 if(!isIpOk())return;
 if(!isNameOk())return;
 if(contacts->reName(EIp->Text.c_str(), EName->Text.c_str()))msgOk();
 else msgError("ContactNotExists");
}
//---------------------------------------------------------------------------

void __fastcall TDlgCntact::BEraseClick(TObject *Sender)
{
 if(!isIpOk())return;
 if(contacts->erase(EIp->Text.c_str()))msgOk();
 else msgError("ContactNotExists");

}
//---------------------------------------------------------------------------

void __fastcall TDlgCntact::BAddClick(TObject *Sender)
{
 if(!isIpOk())return;
 if(!isNameOk())return;
 if(contacts->add(EIp->Text.c_str(), EName->Text.c_str()))msgOk();
 else msgError("ContactAlreadyExists");
}
//---------------------------------------------------------------------------

void TDlgCntact::loadPosition()
{
 if(dlgActiv == 0)
 {
  dlgActiv = 1;
  Left = params->getValue("DlgContactX");
  Top = params->getValue("DlgContactY");
 }
}
void TDlgCntact::savePosition()
{
 if(dlgActiv == 1)
 {
  int left = Left;
  int top = Top;
  if((left > 0)&&(top > 0))
  {
    params->setValue("DlgContactX",left);
    params->setValue("DlgContactY",top);
  }
 }
}

void __fastcall TDlgCntact::FormShow(TObject *Sender)
{
 loadPosition();
}
//---------------------------------------------------------------------------
void TDlgCntact::tiker()
{
  if(++timerMsg == 4)
   if(Visible) LMsgError->Caption = "";
}

bool TDlgCntact::isIpOk()
{
 unsigned long myIp = u_longGetMyIp();
 unsigned long tIp = myInetAddr(EIp->Text.c_str());
 if((myIp == tIp)||(tIp == 0))
 {  ipError();  return 0; }
 if(strcmp(EIp->Text.c_str(), charIp(tIp)) != 0)
 {  ipError();  return 0; }
 return 1;
}
bool TDlgCntact::isNameOk()
{
 AnsiString s = EName->Text.Trim();
 EName->Text = s;
 if(EName->Text.Length() < 3)
 {  shortNameError(); return 0;}
 return 1;
}

void TDlgCntact::msgError(char *s)
{
 timerMsg = 0;
 LMsgError->Caption = lang->translate("Error") + ": " + lang->translate(s) + "!";
 LMsgError->Font->Color = clMaroon;
 PostMessage(h_Wnd,WM_UI1,0,_ERROR_PLAY);
}
void TDlgCntact::msgOk()
{
 timerMsg = 0;
 LMsgError->Font->Color = clGreen;
 LMsgError->Caption = lang->translate("Ok") + "!";
}
void TDlgCntact::ipError()
        {msgError("InvalidIPAdress");}
void TDlgCntact::shortNameError()
        {msgError("ShortUserName");}

void TDlgCntact::refreshCaptions()
{
  Caption = lang->translate("EditContacts") + ".";
  Label2->Caption = lang->translate("UserIpAdress") + ":";
  BClear->Caption = lang->translate("Clear");
  Label1->Caption = lang->translate("UserName") + ":";
  BAdd->Caption = lang->translate("Add");
  BErase->Caption = lang->translate("Erase");
  BRename->Caption = lang->translate("Rename");
  BClose->Caption = lang->translate("Close");


}

