/*
 * Copyright 2004 by Ivan Sorokin.
 *THERE IS ABSOLUTELY NO WARRANTY FOR THIS SOFTWARE.
 * http://phonesnd.com
 * mailto: phonesnd@yandex.ru  
*/

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "DlgOptions.h"
#include "sndUtils.h"
#include "netUtils.h"
#include "params.h"
#include "cLanguage.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
__fastcall TDlgOption::TDlgOption(TComponent* Owner,CParams *params)
        : TForm(Owner)
{
 this->params = params;
 h_Wnd = (void*)params->getValue("_hWndMain");
 lang = (CLanguage*)params->getValue("_CLanguage");
 isChanged = 0;
 isTestVoice = 0;
 isTestVoicePrev = -1;
 im = 0;
 timerMsg = 0;

}

void __fastcall TDlgOption::FormCreate(TObject *Sender)
{
 ComboBoxMc->Clear();
 ComboBoxMc->Items->Add("system");
 for(int i=0; i < getNumDevsMc(); i++)
 { char b[50]; memset(b,0,sizeof(b));
   if(getNameDevsMc(i, b, sizeof(b) - 1))ComboBoxMc->Items->Add(b);
 }
 deviceMc = params->getValue("deviceMc");
 if(deviceMc > getNumDevsMc()) deviceMc = 0;
 params->setValue("deviceMc",deviceMc);


 ComboBoxMc->ItemIndex = deviceMc;

 ComboBoxSp->Clear();
 ComboBoxSp->Items->Add("system");
 for(int i=0; i < getNumDevsSp(); i++)
 { char b[50]; memset(b,0,sizeof(b));
   if(getNameDevsSp(i, b, sizeof(b) - 1))ComboBoxSp->Items->Add(b);
 }

 deviceSp = params->getValue("deviceSp");
 if(deviceSp > getNumDevsSp()) deviceSp = 0;
 params->setValue("deviceSp",deviceSp);

 ComboBoxSp->ItemIndex = deviceSp;
 dlgActiv = 0;
 LMsgError->Caption = "";

 refreshCaptions();
}

void __fastcall TDlgOption::ButtonCancelClick(TObject *Sender)
{
 Close();
}

void __fastcall TDlgOption::ButtonAcceptClick(TObject *Sender)
{
 acceptData();
}

void __fastcall TDlgOption::ComboBoxMcChange(TObject *Sender)
{
 deviceMc = ComboBoxMc->ItemIndex;

 ButtonAccept->Enabled = true;
 isTestVoice = 0;
 if(isTestVoice&&ButtonAccept->Enabled) acceptData();
 setCaptoinTest();
}

void __fastcall TDlgOption::ComboBoxSpChange(TObject *Sender)
{
 deviceSp = ComboBoxSp->ItemIndex;

 ButtonAccept->Enabled = true;
 isTestVoice = 0;
 if(isTestVoice&&ButtonAccept->Enabled) acceptData();
 setCaptoinTest();

}

void __fastcall TDlgOption::FormClose(TObject *Sender, TCloseAction &Action)
{
 isTestVoice = 0;
}

void __fastcall TDlgOption::FormShow(TObject *Sender)
{
  loadPosition();
  timerMsg = 0;
  LErrName->Visible = false;
  LMsgError->Caption = "";

  char buf[1024]; memset(buf,0,sizeof(buf));
  params->getValue("userName",buf);
  userName = buf;
  EUserName->Text = userName;
  isTestVoice = 0;
  deviceMc = params->getValue("deviceMc");
  ComboBoxMc->ItemIndex = deviceMc;
  deviceSp = params->getValue("deviceSp");
  ComboBoxSp->ItemIndex = deviceSp;
  LIp->Caption = charIp(u_longGetMyIp());
  CheckBoxTray->Checked = params->getValue("StartingTray");

  setCaptoinTest();
  ButtonAccept->Enabled = false;
  ButtonCancel->SetFocus();
}

void TDlgOption::loadPosition()
{
 if(dlgActiv == 0)
 {
  dlgActiv = 1;
  Left = params->getValue("DlgOptionsX");
  Top = params->getValue("DlgOptionsY");
 }
}
void TDlgOption::savePosition()
{
 if(dlgActiv == 1)
 {
  int left = Left;
  int top = Top;
  if((left > 0)&&(top > 0))
  {
    params->setValue("DlgOptionsX",left);
    params->setValue("DlgOptionsY",top);
  }
 }
}


void TDlgOption::tiker()
{
  if(++timerMsg == 20)
   if(Visible)
   { LErrName->Visible = false;
     LMsgError->Caption = "";
   }

 if(isTestVoice != isTestVoicePrev)
 {
  if(isTestVoice) Image4->Visible = true;
  else Image4->Visible = false;
 }
 if(isTestVoice)
 {
  TCanvas *Canvas = Image4->Canvas;
  Canvas->FillRect(TRect(0,0,24,119));
  ImageList1->Draw(Canvas, 0, 0, im, true);
  im++;
  if(im > 4)im = 0;
 }
}

void __fastcall TDlgOption::ButtonTestClick(TObject *Sender)
{
 isTestVoice ^= 1;
 if(isTestVoice&&ButtonAccept->Enabled) acceptData();
 setCaptoinTest();
}

void TDlgOption::setCaptoinTest()
{
 if(isTestVoice)
 {
  ButtonTest->Font->Style = TFontStyles()<< fsBold;
  LTestSound->Font->Color = clRed;
  ButtonTest->Caption = lang->translate("Stop");
 }
 else
 {
  ButtonTest->Font->Style = TFontStyles();
  LTestSound->Font->Color = clNavy;
  ButtonTest->Caption = lang->translate("Start");
 }

}

void __fastcall TDlgOption::EUserNameChange(TObject *Sender)
{
 ButtonAccept->Enabled = true;
}

void TDlgOption::acceptData()
{
 params->setValue("deviceMc",deviceMc);
 params->setValue("deviceSp",deviceSp);
 userName=EUserName->Text.Trim();
 if(userName.Length() < 3)
 {
  userName = "";
  EUserName->Text = userName;
  shortNameError();
 }
 char buf[32]; memset(buf,0,sizeof(buf));
 int len = userName.Length();
 if(len > 31) len = 31;
 memcpy(buf,userName.c_str(),len);
 params->setValue("userName",buf);
 isChanged = 1;
 ButtonAccept->Enabled = false;
 params->setValue("StartingTray",CheckBoxTray->Checked);
}

void TDlgOption::shortNameError()
        {msgError("ShortUserName");}

void TDlgOption::msgError(char *s)
{
 timerMsg = 0;
 LMsgError->Caption = lang->translate("Error") + ":  " + lang->translate(s) + "!";
 LErrName->Visible = true;
 PostMessage(h_Wnd,WM_UI1,0,_ERROR_PLAY);
}

void TDlgOption::refreshCaptions()
{
 Caption = lang->translate("Options");
 Label1->Caption = lang->translate("You");
 Label2->Caption = lang->translate("IpAdress") + ":";
 Label4->Caption = lang->translate("Name") + ":";
 Label4->Hint = lang->translate("OptionsUserName");
 EUserName->Hint = lang->translate("OptionsUserName");

 Label2->Hint = lang->translate("OptionsIp");
 LIp->Hint = lang->translate("OptionsIp");

 LTestSound->Caption = lang->translate("TestSound") + ":";
 ButtonAccept->Caption = lang->translate("Accept");
 ButtonCancel->Caption = lang->translate("Close");
 ComboBoxMc->Hint = lang->translate("DeviceMc");
 ComboBoxSp->Hint = lang->translate("DeviceSp");
 CheckBoxTray->Caption = lang->translate("CheckBoxTray");

 setCaptoinTest();
}

void __fastcall TDlgOption::CheckBoxTrayClick(TObject *Sender)
{
 ButtonAccept->Enabled = true;
}


