/*
 * Copyright 2004 by Ivan Sorokin.
 *THERE IS ABSOLUTELY NO WARRANTY FOR THIS SOFTWARE.
 * http://phonesnd.com
 * mailto: phonesnd@yandex.ru  
*/

#pragma hdrstop

#include "spoolsp.h"
#include <memory.h>
void CSpoolSp::setReset(){isReset=1;}

void CSpoolSp::reset()
{memset(data,0,recAll*maxLenRec);
 pNoice=pR=pW; countRVoice = countWVoice; countNoice =0;
}

CSpoolSp::CSpoolSp(int recAll,int maxLenRec)
{
 this->recAll = recAll;
 this->maxLenRec = maxLenRec;
 data = new char[recAll*maxLenRec];
 p = new SpoolCycleBuf[recAll];
 maxSpool = 1;
 memset(data,0,recAll*maxLenRec);
 for(int i=0; i<recAll;i++)
 {
  (p+i)->next = p+i+1;
  (p+i)->data = data+i*maxLenRec;
  (p+i)->len = 0;
  (p+i)->type = 0;
 }
 (p+recAll-1)->next = p;
 pNoice=pW=pR=p; countNoice=0;
 countRVoice = countWVoice = 0;
 setReset();
}

CSpoolSp::~CSpoolSp()
{ delete data; delete p;
}

void CSpoolSp::write(char *data, int len)
{if(isReset)return;
 if(len > maxLenRec)len = maxLenRec;
 pW->type = 1;
 countWVoice++;
 pW->len = len;
 memcpy(pW->data,data,len);
 pW=pW->next;
}

int CSpoolSp::read(char *data, int maxLen)
{
 if(isReset)
 { reset();
  isReset=0;
  memset(data,0,320);
  return 0;
 }
 if((countWVoice - countRVoice) > 3){pR = pR->next;countRVoice++;}
 if((countWVoice - countRVoice) >= maxSpool)
 { memcpy(data,pR->data,320);
   countRVoice++;
   pNoice=pR;
   pR = pR->next;
   countNoice=0;
   return 1;
 }
 else
 {
  countNoice++;
  if(countNoice > 2)   memset(data,0,320);
  else    memcpy(data,pNoice->data,320);
  return  0;
 }
}



