/*
 * Copyright 2004 by Ivan Sorokin.
 *THERE IS ABSOLUTELY NO WARRANTY FOR THIS SOFTWARE.
 * http://phonesnd.com
 * mailto: phonesnd@yandex.ru  
*/

#pragma hdrstop
#include "contacts.h"
#include "params.h"

CContacts::CContacts(CParams *params)
{
 this->params = params;
 h_Wnd = (void*)params->getValue("_hWndMain");
}
CContacts::~CContacts(){ clear();}

CContact *CContacts::contact(int i)
{
 if((i >= vectorIndex.size())||(i<0)) return 0;
 return vectorIndex[i];
}


void CContacts::clear()
{
  mapIp.clear();
  for(int i=0; i < vectorIndex.size(); i++) delete vectorIndex[i];
  vectorIndex.clear();
}

int CContacts::add( char* ip, char* name)
{
 if((strlen(ip) == 0)||(strlen(name) == 0)) return 0;
 if(memcmp(ip,"127.0.",6) == 0) return 0;
 CContact *contact = mapIp[ip];
 if(contact != 0) return 0;
 contact = new CContact(ip,name);
 mapIp[ip] = contact;
 vectorIndex.push_back(contact);
 SendMessage(h_Wnd,WM_UI1,0,_CONTACT_ADD);
 return 1;
}

int CContacts::erase( char* ip)
{
 if(strlen(ip) == 0) return 0;
 CContact *contact = mapIp[ip];
 if(contact == 0) return 0;
 mapIp.erase(ip);
 for(int i = 0; i < vectorIndex.size(); i++)
 {
  contact = vectorIndex[i];
  if(contact == NULL) continue;
  if(strcmp(contact->ip,ip) == 0)
  {
   vectorIndex.erase(vectorIndex.begin() + i);
   delete contact;
   SendMessage(h_Wnd,WM_UI1,i,_CONTACT_ERASE);
   break;
  }
 }
 return 1;
}

int CContacts::erase( int i)
{
 CContact *c = contact(i);
 if(c == 0) return 0;
 return erase(c->ip);
}


int CContacts::reName( char* ip, char* name)
{
 if(strlen(name) == 0) return 0;
 if(strlen(ip) == 0) return 0;
 CContact *contact = mapIp[ip];
 if(contact == 0) return 0;
 strcpy(contact->name,name);
 SendMessage(h_Wnd,WM_UI1,0,_CONTACT_REFRESH);
 return 1;
}

void CContacts::begin(){iterIp=mapIp.begin();}
int CContacts::next( char* ip, char* name)
{
 if(iterIp == mapIp.end())return 0;
 CContact *contact =(*iterIp).second;
 if(contact == 0)
 return 0;
 strcpy(ip,contact->ip);
 strcpy(name,contact->name);
 iterIp++;
 return 1;
}

void CContacts::ping(unsigned long ip)
{
 struct in_addr in; in.S_un.S_addr = ip;
 char* s = inet_ntoa(in);
 if (s == NULL) return;
 CContact *contact = mapIp[s];
 SendMessage(h_Wnd,WM_UI1,ip,_CONTACT_PONG_OUT);
 if(contact == NULL) return;
 contact->pong();
}

void CContacts::pong(unsigned long ip)
{
 struct in_addr in; in.S_un.S_addr = ip;
 char* s = inet_ntoa(in);
 if (s == NULL) return;
 CContact *contact = mapIp[s];
 if(contact == NULL) return;
 contact->pong();
}
void CContacts::offline(unsigned long ip)
{
 struct in_addr in; in.S_un.S_addr = ip;
 char* s = inet_ntoa(in);
 if (s == NULL) return;
 CContact *contact = mapIp[s];
 if(contact == NULL) return;
 contact->offline();
}
void CContacts::tiker()
{
 CContact *contact;
 int i,t;
 int isChanged = 0;
 for(i = 0; i < vectorIndex.size(); i++)
 {
  contact = vectorIndex[i];
  if(contact == NULL) continue;
  contact->tiker(h_Wnd);
  if(contact->isChanged())isChanged = 1;
 }
 if(isChanged) PostMessage(h_Wnd,WM_UI1,0,_CONTACT_REFRESH);

}
bool CContacts::exists(char* ip)
{
 if(mapIp[ip] == 0) return false;
 return true;
}

bool CContacts::getName(unsigned long ip, char* name)
{
 struct in_addr in; in.S_un.S_addr = ip;
 char* s = inet_ntoa(in);
 if (s == NULL) return 0;
 CContact *contact = mapIp[s];
 if(contact == NULL) return 0;
 strcpy(name,contact->name);
 return 1;
}
CContact* CContacts::contact(unsigned long ip)
{
 struct in_addr in; in.S_un.S_addr = ip;
 char* s = inet_ntoa(in);
 if (s == NULL) return 0;
 CContact *contact = mapIp[s];
 return contact;
}
CContact::CContact(char* ip, char* name)
{
 strcpy(this->ip,ip);
 strcpy(this->name,name);
 countPing = 3;
 state = 0;
 prevState = -1;
 timer = 0;
}
CContact::~CContact(){}
bool CContact::isOnline(){return countPing < 3;}
void CContact::pong(){countPing = 0; timer = 21; state = 1;}
void CContact::tiker(void *h_Wnd)
{
 unsigned long uIp;
 if(++timer > 600) timer = 0;
 if((timer == 1)||(timer == 7)||(timer == 15))
 {
  uIp = inet_addr(ip);
  if(uIp == 0) return;
  SendMessage(h_Wnd,WM_UI1,uIp,_CONTACT_PING_OUT);
  countPing++;
  state = isOnline();
 }
}

int CContact::isChanged()
{
 int x = 0;
 if(prevState != state) {prevState = state; x = 1;}
 return x;
}

void CContact::offline()
{
  countPing = 3;
  state = isOnline();
}



