/*
 * Copyright 2004 by Ivan Sorokin.
 *THERE IS ABSOLUTELY NO WARRANTY FOR THIS SOFTWARE.
 * http://phonesnd.com
 * mailto: phonesnd@yandex.ru  
*/

#pragma hdrstop

#include "math.h"
#include "deviceMc.h"
#include "params.h"
#include "utils.h"
#include "sndUtils.h"

CDeviceMc::CDeviceMc(CParams* params):hWav(0),isOpen(false)
{
 this->params = params;
 memset(header, 0,sizeof(WAVEHDR)*SNDNBUF);
 for(int i=0;i<SNDNBUF;i++)
 {	header[i].lpData = hdrData + i*SNDSIZEBUF;
 	header[i].dwBufferLength =  SNDSIZEBUF;
 }
}

CDeviceMc::~CDeviceMc(){stop();}

void CALLBACK CDeviceMc::WaveInCallback(HWAVEIN hw, UINT uMsg,
			  DWORD_PTR dwInstance, DWORD_PTR dwParam1, DWORD dwParam2)
{WAVEHDR* curhdr = (WAVEHDR*)dwParam1;
 CDeviceMc* p=(CDeviceMc*)dwInstance;
 if(!p->isOpen)return;
 if(uMsg != WIM_DATA)return;
 p->frameMc(curhdr->lpData, p->classDlgMain);
 waveInAddBuffer(hw, curhdr, sizeof(WAVEHDR));
}

void CDeviceMc::restart(){ stop(); start();}

void CDeviceMc::stop()
{int i;
 if(hWav)
 {	isOpen=false;	waveInReset(hWav);
	for(i=0;i<SNDNBUF;i++) waveInUnprepareHeader(hWav,header+i, sizeof(WAVEHDR));
	i=3;while(i--)waveInReset(hWav);
	waveInClose(hWav); hWav=0;
 }
}

void CDeviceMc::start()
{
 if(isOpen)return;
 int device = params->getValue("deviceMc") - 1;
 params->getValue("_frameMc",(void**)&frameMc);
 params->getValue("_classDlgMain",(void**)&classDlgMain);

 if(classDlgMain == NULL) return;
 if(frameMc == NULL)return;

 MMRESULT mmr;
 WAVEFORMATEX wfx; setWAVEFORMATEX(&wfx);
 memset(hdrData,0,SNDSIZEBUF*SNDNBUF);

 if(waveInOpen(&hWav,device, &wfx,(DWORD_PTR)WaveInCallback ,(DWORD_PTR)this, CALLBACK_FUNCTION)
	== MMSYSERR_NOERROR)
 {	isOpen=true;
 	for(int i=0;i<SNDNBUF;i++)
	{  mmr = waveInPrepareHeader(hWav, header + i, sizeof(WAVEHDR));
	   mmr = waveInAddBuffer(hWav, header + i, sizeof(WAVEHDR));
	}
	mmr = waveInStart(hWav);
 }
}

