/*
 * Copyright 2004 by Ivan Sorokin.
 *THERE IS ABSOLUTELY NO WARRANTY FOR THIS SOFTWARE.
 * http://phonesnd.com
 * mailto: phonesnd@yandex.ru  
*/

#pragma hdrstop

#include "math.h"
#include "deviceSp.h"
#include "params.h"
#include "utils.h"
#include "sndUtils.h"

CDeviceSp::CDeviceSp(CParams* params):hWav(0),isOpen(false)
{
 this->params = params;
 memset(header, 0,sizeof(WAVEHDR)*SNDNBUF);
 for(int i=0;i<SNDNBUF;i++)
 {	header[i].lpData = hdrData + i*SNDSIZEBUF;
 	header[i].dwBufferLength =  SNDSIZEBUF;
 }
}

CDeviceSp::~CDeviceSp(){stop();}

void CALLBACK CDeviceSp::WaveOutCallback(HWAVEOUT hw, UINT uMsg,
			  DWORD_PTR dwInstance, DWORD_PTR dwParam1, DWORD dwParam2)
{WAVEHDR* curhdr = (WAVEHDR*)dwParam1;
CDeviceSp* p=(CDeviceSp*)dwInstance;
if(!p->isOpen)return;
if(uMsg != WOM_DONE)return;
p->frameSp(curhdr->lpData, p->classDlgMain);
p->frameSp(curhdr->lpData+320, p->classDlgMain);
curhdr->dwBytesRecorded=SNDSIZEBUF;
waveOutWrite(hw, curhdr, sizeof(WAVEHDR));
}

void CDeviceSp::restart(){ stop(); start();}

void CDeviceSp::stop()
{int i;
 if(hWav)
 {	isOpen=false;	waveOutReset(hWav);
	for(i=0;i<SNDNBUF;i++) waveOutUnprepareHeader(hWav,header+i, sizeof(WAVEHDR));
	i=3;while(i--)waveOutReset(hWav);
	waveOutClose(hWav); hWav=0;
 }
}

void CDeviceSp::start()
{
 if(isOpen)return;
 int device = params->getValue("deviceSp") - 1;
 params->getValue("_frameSp",(void**)&frameSp);
 params->getValue("_classDlgMain",(void**)&classDlgMain);

 if(classDlgMain == NULL) return;
 if(frameSp == NULL)return;

 MMRESULT mmr;
 WAVEFORMATEX wfx;  setWAVEFORMATEX(&wfx);
 memset(hdrData,0,SNDSIZEBUF*SNDNBUF);
 if(waveOutOpen(&hWav, device, &wfx,(DWORD_PTR)WaveOutCallback ,(DWORD_PTR)this, CALLBACK_FUNCTION)
	== MMSYSERR_NOERROR)
 {	isOpen = true;
	waveOutPause(hWav);
	for(int i=0; i < SNDNBUF; i++)
	{  mmr = waveOutPrepareHeader(hWav, header + i, sizeof(WAVEHDR));
	   mmr = waveOutWrite(hWav, header + i, sizeof(WAVEHDR));
	}
	waveOutRestart(hWav);
 }
}

