/*
 * Copyright 2004 by Ivan Sorokin.
 *THERE IS ABSOLUTELY NO WARRANTY FOR THIS SOFTWARE.
 * http://phonesnd.com
 * mailto: phonesnd@yandex.ru  
*/

#pragma hdrstop

#include "mixer.h"
#include "params.h"

//----------- Class CMixer -------
//==================================
CMixer::CMixer(CParams *params)
{
this->params = params;
enableCtrl_ExtVol = new bool[LINEMIXALL];
crtlDetails_ExtVol= new MIXERCONTROLDETAILS[LINEMIXALL];
paDetails_ExtVol = new MIXERCONTROLDETAILS_UNSIGNED[LINEMIXALL];
for(int i=0;i< LINEMIXALL; i++)enableCtrl_ExtVol[i]=false;
hMixer=NULL;
iDev = 0;
}
//==================================
CMixer::~CMixer(void){}
//==================================
void CMixer::initLineMixer(MIXERLINE* line,int dst,int src)
{line->cbStruct = sizeof(MIXERLINE);
 line->dwSource=src;
 line->dwDestination=dst;
}
//==================================
void CMixer::initLineCtrl(MIXERLINE* line,MIXERLINECONTROLS* lineCtrl,MIXERCONTROL* ctrl,DWORD ctrlType)
{lineCtrl->cbStruct=sizeof(MIXERLINECONTROLS);
 lineCtrl->dwLineID=line->dwLineID;
 lineCtrl->cControls=line->cControls;
 lineCtrl->pamxctrl=ctrl;
 lineCtrl->cbmxctrl=sizeof(MIXERCONTROL);
 lineCtrl->dwControlType=ctrlType;
 ctrl->cbStruct=sizeof(MIXERLINECONTROLS);
}
//==================================
void CMixer::initCtrlDetails(MIXERCONTROLDETAILS* ctrlDetails,
              LPVOID paDetails,MIXERCONTROL* ctrl,DWORD ctrlType)
{ctrlDetails->cbStruct = sizeof(MIXERCONTROLDETAILS );
 ctrlDetails->cChannels = 1;
 ctrlDetails->dwControlID = ctrl->dwControlID;
 ctrlDetails->cMultipleItems = ctrl->cMultipleItems;
 //if(ctrlDetails->cMultipleItems > 15)ctrlDetails->cMultipleItems = 15;
 if((ctrlType==MIXERCONTROL_CONTROLTYPE_MUX)||
	(ctrlType==MIXERCONTROL_CONTROLTYPE_MUTE))  ctrlDetails->cbDetails = sizeof(MIXERCONTROLDETAILS_BOOLEAN);
 else ctrlDetails->cbDetails = sizeof(MIXERCONTROLDETAILS_UNSIGNED);
 ctrlDetails->paDetails = paDetails;
}
//==================================
bool CMixer::getLineInfo(MIXERLINE* line,DWORD type)
{if(mixerGetLineInfo((HMIXEROBJ)hMixer, line, type | MIXER_OBJECTF_HMIXER)==0)
 return true; else return false;
}
//==================================
bool CMixer::getLineControls(MIXERLINECONTROLS* lineCtrl)
{ if(mixerGetLineControls((HMIXEROBJ)hMixer,lineCtrl,
	 MIXER_GETLINECONTROLSF_ONEBYTYPE | MIXER_OBJECTF_HMIXER)==0)
 return true; else return false;
}
//==================================
bool CMixer::getControlDetails(MIXERCONTROLDETAILS* ctrlDetails)
{ MMRESULT yy=mixerGetControlDetails((HMIXEROBJ)hMixer, ctrlDetails,
         MIXER_GETCONTROLDETAILSF_VALUE | MIXER_OBJECTF_HMIXER);
 if(yy==0) return true;
 else return false;
}
//==================================
bool CMixer::setControlDetails(MIXERCONTROLDETAILS* ctrlDetails)
{ if(mixerSetControlDetails((HMIXEROBJ)hMixer, ctrlDetails,
         MIXER_GETCONTROLDETAILSF_VALUE | MIXER_OBJECTF_HMIXER)==0)
 return true; else return false;
}
//==================================
bool CMixer::setControlDetailsBool(MIXERLINE* line,bool data,DWORD ctrlType)
{ if(!((ctrlType == MIXERCONTROL_CONTROLTYPE_MUTE)||(ctrlType == MIXERCONTROL_CONTROLTYPE_MUX)))
   return false;;
  MIXERCONTROLDETAILS crtlDetailsBool;
  MIXERCONTROLDETAILS_BOOLEAN paDetailsBool;
  MIXERCONTROL ctrl;
  MIXERLINECONTROLS lineCtrl;
  initLineCtrl(line,&lineCtrl,&ctrl,ctrlType);
  if(getLineControls(&lineCtrl))
  {
   initCtrlDetails(&crtlDetailsBool,&paDetailsBool,&ctrl,ctrlType);
   if(getControlDetails(&crtlDetailsBool))
   {if(paDetailsBool.fValue != (long)data)
    { paDetailsBool.fValue = data;
      setControlDetails(&crtlDetailsBool);
	}
	return true;
   }
  }
  return false;
}
//==================================
void CMixer::createCtrl_ExtVol(MIXERLINE* line,int idExtVol)
{ DWORD ctrlType = MIXERCONTROL_CONTROLTYPE_VOLUME;
  MIXERCONTROL ctrl;
  MIXERLINECONTROLS lineCtrl;
  initLineCtrl(line,&lineCtrl,&ctrl,ctrlType);
  if(getLineControls(&lineCtrl))
  {initCtrlDetails(crtlDetails_ExtVol+idExtVol,paDetails_ExtVol+idExtVol,&ctrl,ctrlType);
   if(getControlDetails(crtlDetails_ExtVol+idExtVol))
    enableCtrl_ExtVol[idExtVol] = setControlDetails(crtlDetails_ExtVol+idExtVol);
  }
}
//==================================
bool CMixer::getExtVol(LPARAM lParam,unsigned* vol,int i)
{if(enableCtrl_ExtVol[i]==false)return false;
 if(crtlDetails_ExtVol[i].dwControlID != lParam)return false;
 if(!getControlDetails(crtlDetails_ExtVol+i))return false;
 *vol=paDetails_ExtVol[i].dwValue; return true;
}
//==================================
void CMixer::setExtVol(unsigned vol,int i)
{ if(enableCtrl_ExtVol[i]==false)return;
  paDetails_ExtVol[i].dwValue=vol;
  setControlDetails(crtlDetails_ExtVol+i);
}
//==================================
void CMixer::mixClose(){if(hMixer==NULL) return ; mixerClose(hMixer); hMixer=NULL;}
//==================================
bool CMixer::mixOpen(int iDev, DWORD mixer_objectf)
{UINT uMxId;   this->iDev = iDev;
 DWORD hWnd = (DWORD)params->getValue("_hWndMain");
 if(mixerGetID((HMIXEROBJ)iDev,&uMxId,mixer_objectf)>0)return false;
 if(mixerOpen(&hMixer,uMxId,(DWORD)hWnd,0,CALLBACK_WINDOW)>0)return false;
 return true;
}

//----------- Class CMixerMc -------
//==================================
CMixerMc::CMixerMc(CParams *params):CMixer(params)
{
}
//==================================
void CMixerMc::start()
{stop();
 int iDev = params->getValue("deviceMc") - 1;
 if(!mixOpen(iDev,MIXER_OBJECTF_WAVEIN))return;
 int linesMus=0;
 DWORD ctrlType;
 MIXERCONTROL ctrl;
 MIXERLINE line;
 MIXERLINECONTROLS lineCtrl;
 MIXERCONTROLDETAILS crtlDetailsMux;
 MIXERCONTROLDETAILS_BOOLEAN paDetailsMux[20];
 int sm=0;

 initLineMixer(&line,1,0);//1-
 if(getLineInfo(&line,MIXER_GETLINEINFOF_DESTINATION))
 {
  if(!setControlDetailsBool(&line,false,MIXERCONTROL_CONTROLTYPE_MUTE))sm=0;
  else sm = 0;

  ctrlType = MIXERCONTROL_CONTROLTYPE_MUX;
  initLineCtrl(&line,&lineCtrl,&ctrl,ctrlType);
  if(getLineControls(&lineCtrl))
  {
   initCtrlDetails(&crtlDetailsMux,&paDetailsMux,&ctrl,ctrlType);
   if(getControlDetails(&crtlDetailsMux))linesMus=ctrl.cMultipleItems;
  }
 }
  for(int i=0;i<linesMus;i++)
 {initLineMixer(&line,1,i);
  if(getLineInfo(&line,MIXER_GETLINEINFOF_SOURCE))
  {if(line.dwComponentType == MIXERLINE_COMPONENTTYPE_SRC_MICROPHONE)
   {
     int k=line.dwSource;
     createCtrl_ExtVol(&line,LINEMIXREC_MIC);
     break;
   }
  }
 }
}
//==================================
void CMixerMc::stop(){mixClose(); enableCtrl_ExtVol[LINEMIXREC_MIC]=false;}
//==================================
void CMixerMc::setVol(unsigned vol){ setExtVol(vol,LINEMIXREC_MIC);}
//==================================
bool CMixerMc::getVol(LPARAM lParam,unsigned* vol){ return getExtVol(lParam,vol,LINEMIXREC_MIC);}
//==================================
bool CMixerMc::getVol(unsigned* vol){ return getExtVol(crtlDetails_ExtVol[LINEMIXREC_MIC].dwControlID,vol,LINEMIXREC_MIC);}
//==================================

//----------- Class CMixerSp -------
//==================================
CMixerSp::CMixerSp(CParams *params):CMixer(params)
{
}
//==================================
void CMixerSp::start()
{stop();
 int iDev = params->getValue("deviceSp") - 1;
 if(!mixOpen(iDev,MIXER_OBJECTF_WAVEOUT))return;
 MIXERLINE line; int mixLines=0;
 initLineMixer(&line,0,0);
 if(getLineInfo(&line,MIXER_GETLINEINFOF_DESTINATION))
 {mixLines=line.cConnections;
  createCtrl_ExtVol(&line,LINEMIXPLAY_COMMON);
  //setControlDetailsBool(&line,false,MIXERCONTROL_CONTROLTYPE_MUTE);
 }
 for(int i=0;i<mixLines;i++)
 {initLineMixer(&line,0,i);
  if(getLineInfo(&line,MIXER_GETLINEINFOF_SOURCE))
  {if(line.dwComponentType == MIXERLINE_COMPONENTTYPE_SRC_MICROPHONE)
   {//setControlDetailsBool(&line,true,MIXERCONTROL_CONTROLTYPE_MUTE);
    continue;
   }
   if(line.dwComponentType == MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT)
   {if(enableCtrl_ExtVol[LINEMIXPLAY_WAVE]) continue;
    setControlDetailsBool(&line,false,MIXERCONTROL_CONTROLTYPE_MUTE);
    createCtrl_ExtVol(&line,LINEMIXPLAY_WAVE);
	continue;
   }
  }
 }
}
//==================================
void CMixerSp::stop()
{mixClose();
 enableCtrl_ExtVol[LINEMIXPLAY_COMMON]=false;
 enableCtrl_ExtVol[LINEMIXPLAY_WAVE]=false;
}
//==================================
void CMixerSp::setVol(unsigned vol)
{ setExtVol(vol,LINEMIXPLAY_COMMON);
  setExtVol(vol,LINEMIXPLAY_WAVE);
}
//==================================
bool CMixerSp::getVol(LPARAM lParam,unsigned* vol){ return getExtVol(lParam,vol,LINEMIXPLAY_WAVE);}
//==================================
bool CMixerSp::getVol(unsigned* vol){ return getExtVol(crtlDetails_ExtVol[LINEMIXPLAY_WAVE].dwControlID,vol,LINEMIXPLAY_WAVE);}
//==================================
