#ifndef MIXERH
#define MIXERH

#pragma once

#include <windows.h>
#include <mmsystem.h>

class CParams;
class CMixer
{
public:
	CParams *params;
	HMIXER hMixer;
	int iDev;
	void initLineMixer(MIXERLINE* line,int dst,int src);
	void initLineCtrl(MIXERLINE* line,MIXERLINECONTROLS* lineCtrl,MIXERCONTROL* ctrl,DWORD ctrlType);
	void initCtrlDetails(MIXERCONTROLDETAILS* ctrlDetails, LPVOID paDetails,MIXERCONTROL* ctrl,DWORD ctrlType);
	void createCtrl_ExtVol(MIXERLINE* line,int idExtVol);
	bool setControlDetailsBool(MIXERLINE* line,bool data,DWORD type);
	bool getLineInfo(MIXERLINE* line,DWORD type);
	bool getLineControls(MIXERLINECONTROLS* lineCtrl);
	bool getControlDetails(MIXERCONTROLDETAILS* ctrlDetails);
	bool setControlDetails(MIXERCONTROLDETAILS* ctrlDetails);
	bool getExtVol(LPARAM lParam,unsigned* vol,int i);
	void setExtVol(unsigned vol,int i);

	CMixer(CParams *params);	
	~CMixer(void);
	void mixClose();
	bool mixOpen(int iDev, DWORD mixer_objectf);
	
	enum LINEMIXVOLUME
	{LINEMIXPLAY_COMMON, LINEMIXPLAY_WAVE, LINEMIXREC_MIC, LINEMIXALL};

	bool* enableCtrl_ExtVol;
	MIXERCONTROLDETAILS* crtlDetails_ExtVol;
	MIXERCONTROLDETAILS_UNSIGNED* paDetails_ExtVol;
};

class CMixerMc: public CMixer 
{   
public:
	CMixerMc(CParams *params);	
	void start();
	void stop();
	void setVol(unsigned vol);
    bool getVol(LPARAM lParam,unsigned* vol);
    bool getVol(unsigned* vol);
};

class CMixerSp: public CMixer 
{   
public:
	CMixerSp(CParams *params);	
	void start();
	void stop();
	void setVol(unsigned vol);
    bool getVol(LPARAM lParam,unsigned* vol);
    bool getVol(unsigned* vol);
};
#endif
