/*
 * Copyright 2004 by Ivan Sorokin.
 *THERE IS ABSOLUTELY NO WARRANTY FOR THIS SOFTWARE.
 * http://phonesnd.com
 * mailto: phonesnd@yandex.ru  
*/

#pragma hdrstop

#include <windows.h>
#include "params.h"
#include <stdio.h>
#include <Registry.hpp>

CParams::CParams()
{
 loadParams();
}
CParams::~CParams(){saveParams();}

void CParams::loadParams()
{
 char sKey[512],sVal[512];
 TRegistry *Reg = new TRegistry;
 AnsiString key ="\\Software\\P2P VoIp\\params";
 AnsiString v,buf;
 if(Reg->OpenKey(key,false))
 {
  int i=0;
  while(1)
  {
   v = IntToStr(i);
   if(!Reg->ValueExists(v))break;
   buf = Reg->ReadString(v);
   i++;
   if(sscanf(buf.c_str(),"%s = %s",sKey,sVal)!=2)continue;
   strcpy(sVal,buf.c_str() + strlen(sKey) + 3);
   setValue(sKey,sVal);
  }
  Reg->CloseKey();
 }

 key ="\\Software\\P2P VoIp\\contacts";
 if(Reg->OpenKey(key,false))
 {
  for(int i=0;i<20;i++)
  {
   v = IntToStr(i);
   if(!Reg->ValueExists(v))break;
   buf = Reg->ReadString(v);
   if(sscanf(buf.c_str(),"%s %s",sKey,sVal)!=2)continue;
   int len = strlen(sKey);
   strcpy(sVal,buf.c_str() + len + 1);
   addContact(sKey,sVal);
  }
  Reg->CloseKey();
 }

}

void CParams::saveParams()
{
 TRegistry *Reg = new TRegistry;
 AnsiString key ="\\Software\\P2P VoIp\\params";
 AnsiString v;
 char buf[1024];
 if(Reg->OpenKey(key,true))
 {
  int i=0;
  for(iterParams=mapParams.begin(); iterParams != mapParams.end(); iterParams++)
  {
   str sFirst =(*iterParams).first;
   str sSecond =(*iterParams).second;
   if(sFirst[0] == '_') continue;
   sprintf(buf,"%s = %s",sFirst.c_str(),sSecond.c_str());
   v = IntToStr(i);
   Reg->WriteString(v,buf);
   i++;
  }
  Reg->CloseKey();
 }

 key ="\\Software\\P2P VoIp\\contacts";

 if(Reg->OpenKey(key,true))
 {
  for(int i=0; i< 20;i++) Reg->WriteString(IntToStr(i),"");
  int i=0;
  for(iterContacts=mapContacts.begin(); iterContacts != mapContacts.end(); iterContacts++)
  {
   if(i>19)continue;
   str sFirst =(*iterContacts).first;
   str sSecond =(*iterContacts).second;
   if( sFirst.length() == 0)continue;
   if( sSecond.length() == 0)continue;
   sprintf(buf,"%s %s",sFirst.c_str(),sSecond.c_str());
   v = IntToStr(i);
   Reg->WriteString(v,buf);
   i++;
  }
  Reg->CloseKey();
 }

}

void CParams::setValue(char* key, char* val){ mapParams[key]=val; }
void CParams::setValue(char* key, void* vVal){ setValue(key,(int)vVal); }
void CParams::setValue(char* key, int intVal)
{
 char buf[256];
 itoa(intVal,buf,10);
 setValue(key, buf);
}


bool CParams::getValue(char* key, char* val)
{
 str val_= mapParams[key];
 if(val_.length()==0)
 { val[0]=0;
   return false;
 }
 strcpy(val,val_.c_str());
 return true;
}
bool CParams::getValue(char* key, int* intVal)
{
 char buf[256];
 if(!getValue(key, buf))
 {
  *intVal = 0;
  return false;
 }
 *intVal = atoi(buf);
 return true;
}
int CParams::getValue(char* key){ int i;  getValue(key,&i); return i;}
bool CParams::getValue(char* key, void** vVal)
{
 char buf[256];
 if(!getValue(key, buf))
 {
  vVal = NULL;
  return false;
 }
 *vVal =(void*)strtoul(buf,NULL,10);
 return true;
}


void CParams::addContact(char* ip, char* name)
{
 if((strlen(ip)==0)||(strlen(name)==0))return;
 mapContacts[ip]=name;
}

void CParams::clearContact(){ mapContacts.clear();}

void CParams::beginContact(){iterContacts=mapContacts.begin();}

int  CParams::nextContact(char* ip, char* name)
{
 if(iterContacts == mapContacts.end())return 0;
 str sFirst =(*iterContacts).first;
 str sSecond =(*iterContacts).second;
 if( sFirst.length() == 0)return 0;
 if( sSecond.length() == 0)return 0;
 strcpy(ip,sFirst.c_str());
 strcpy(name,sSecond.c_str());
 iterContacts++;
 return 1;
}

int  CParams::getContact(char* ip, char* name)
{
 str sName;
 sName = mapContacts[ip];
 if( sName.length() == 0)return 0;
 strcpy(name,sName.c_str());
 return 1;
}



